/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.testdata.TestField;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;
import javax.swing.WindowConstants;
import org.apache.log4j.Logger;
import org.visnow.vn.engine.core.ParameterProxy;
import static org.visnow.vn.lib.basic.testdata.TestField.TestFieldShared.*;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.UIStyle;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{
    private static final Logger LOGGER = Logger.getLogger(GUI.class);
    private ParameterProxy parameterProxy;

    //Unfortunately this flag is necessary for JList :/
    private boolean componentListActive = true;
    private String[] geoms3D = { TRIVIAL, UNIFORM_RECT, RECTANGULAR, AFFINE, CURVILINEAR };
    private String[] geoms2D = { TRIVIAL, UNIFORM_RECT, RECTANGULAR, AFFINE, RADIAL, SPHERICAL };
    private String[] geoms1D = { TRIVIAL, UNIFORM_RECT, AFFINE, CURVILINEAR };

    /**
     * Creates new form SliceUI
     */
    public GUI()
    {
        initComponents();
    }

    public void setParameterProxy(ParameterProxy parameterProxy)
    {
        this.parameterProxy = parameterProxy;
    }

    private void updateComponentList(int dim)
    {
        switch (dim) {
            case 3:
                componentList.setListData(FIELD_NAMES_3D);
                break;
            case 2:
                componentList.setListData(FIELD_NAMES_2D);
                break;
            default:
                componentList.setListData(FIELD_NAMES_1D);
                break;
        }
    }

    void updateGUI(ParameterProxy p)
    {
        final int dimNum = p.get(NUMBER_OF_DIMENSIONS);
        final int dimLen = p.get(DIMENSION_LENGTH);
        final int[] selectedComponents = p.get(SELECTED_COMPONENTS);

        switch (dimNum) {
            case 3:
                radioButton3.setSelected(true);
                break;
            case 2:
                radioButton2.setSelected(true);
                break;
            default:
                radioButton1.setSelected(true);
                break;
        }

        dimSlider.setValue(dimLen);
        updateComponentList(dimNum);
        componentList.setSelectedIndices(selectedComponents);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        radioButton1 = new org.visnow.vn.gui.swingwrappers.RadioButton();
        radioButton2 = new org.visnow.vn.gui.swingwrappers.RadioButton();
        radioButton3 = new org.visnow.vn.gui.swingwrappers.RadioButton();
        jLabel2 = new javax.swing.JLabel();
        dimSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        jScrollPane1 = new javax.swing.JScrollPane();
        componentList = new javax.swing.JList();
        geometryPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        generateCoordsBox = new javax.swing.JCheckBox();
        geometryTypeCombo = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        structTypeCombo = new javax.swing.JComboBox<>();

        setLayout(new java.awt.GridBagLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Dimensions: ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jLabel1, gridBagConstraints);

        buttonGroup1.add(radioButton1);
        radioButton1.setText("1D");
        radioButton1.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                dimensionChangeAction(evt);
            }
        });
        jPanel1.add(radioButton1, new java.awt.GridBagConstraints());

        buttonGroup1.add(radioButton2);
        radioButton2.setText("2D");
        radioButton2.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                dimensionChangeAction(evt);
            }
        });
        jPanel1.add(radioButton2, new java.awt.GridBagConstraints());

        buttonGroup1.add(radioButton3);
        radioButton3.setSelected(true);
        radioButton3.setText("3D");
        radioButton3.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                dimensionChangeAction(evt);
            }
        });
        jPanel1.add(radioButton3, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 0, 4);
        add(jPanel1, gridBagConstraints);

        jLabel2.setText("Resolution:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 0, 4);
        add(jLabel2, gridBagConstraints);

        dimSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        dimSlider.setGlobalMin(2);
        dimSlider.setMax(300);
        dimSlider.setMin(2);
        dimSlider.setSubmitOnAdjusting(false);
        dimSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                dimSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 4, 2, 4);
        add(dimSlider, gridBagConstraints);

        componentList.setVisibleRowCount(10);
        componentList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                componentListValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(componentList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jScrollPane1, gridBagConstraints);

        geometryPanel.setLayout(new java.awt.GridBagLayout());

        jLabel3.setText("Geometry:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 14);
        geometryPanel.add(jLabel3, gridBagConstraints);

        generateCoordsBox.setText("generate coords");
        generateCoordsBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                generateCoordsBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        geometryPanel.add(generateCoordsBox, gridBagConstraints);

        geometryTypeCombo.setModel(new DefaultComboBoxModel(geoms2D));
        geometryTypeCombo.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                geometryTypeComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        geometryPanel.add(geometryTypeCombo, gridBagConstraints);

        jLabel4.setText("Structure:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        geometryPanel.add(jLabel4, gridBagConstraints);

        structTypeCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "regular", "irregular (box)", "triangulated" }));
        structTypeCombo.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                structTypeComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        geometryPanel.add(structTypeCombo, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(geometryPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void componentListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_componentListValueChanged
    {//GEN-HEADEREND:event_componentListValueChanged
        if (componentListActive && !evt.getValueIsAdjusting()) {
//            LOGGER.debug(parameters.isParameterActive() + " " + Arrays.toString(componentList.getSelectedIndices()));
            parameterProxy.set(SELECTED_COMPONENTS, componentList.getSelectedIndices());
        }
    }//GEN-LAST:event_componentListValueChanged

    private void dimensionChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_dimensionChangeAction
    {//GEN-HEADEREND:event_dimensionChangeAction
        int dimNum = evt.getSource() == radioButton1 ? 1 : evt.getSource() == radioButton2 ? 2 : 3;
        componentListActive = false;
        updateComponentList(dimNum);
        componentList.setSelectedIndices(new int[]{0, 1});
        componentListActive = true;
        switch (dimNum) {
            case 1:
                dimSlider.setAll(100, 10000, 1000);
                geometryTypeCombo.setModel(new DefaultComboBoxModel(geoms1D));
                geometryTypeCombo.setSelectedIndex(1);
                break;
            case 2:
                dimSlider.setAll(50, 1000, 200);
                geometryTypeCombo.setModel(new DefaultComboBoxModel(geoms2D));
                geometryTypeCombo.setSelectedIndex(1);
                break;
            case 3:
                dimSlider.setAll(5, 300, 30);
                geometryTypeCombo.setModel(new DefaultComboBoxModel(geoms3D));
                geometryTypeCombo.setSelectedIndex(1);
                break;
        }
        geometryPanel.setVisible(dimNum > 1);
        parameterProxy.set(SELECTED_COMPONENTS, new int[]{0, 1},
                           NUMBER_OF_DIMENSIONS, dimNum,
                           DIMENSION_LENGTH, (Integer) dimSlider.getValue());
    }//GEN-LAST:event_dimensionChangeAction

    private void dimSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_dimSliderUserChangeAction
    {//GEN-HEADEREND:event_dimSliderUserChangeAction
        parameterProxy.set(DIMENSION_LENGTH, (Integer) dimSlider.getValue());
    }//GEN-LAST:event_dimSliderUserChangeAction

    private void generateCoordsBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_generateCoordsBoxActionPerformed
    {//GEN-HEADEREND:event_generateCoordsBoxActionPerformed
        parameterProxy.set(CREATE_COORDS, generateCoordsBox.isSelected());
    }//GEN-LAST:event_generateCoordsBoxActionPerformed

    private void geometryTypeComboActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_geometryTypeComboActionPerformed
    {//GEN-HEADEREND:event_geometryTypeComboActionPerformed
        String selGeometry = (String) geometryTypeCombo.getSelectedItem();
        switch (selGeometry) {
        case TRIVIAL:
            parameterProxy.set(GEOMETRY, GeometryType.TRIVIAL_GEOM);
            break;
        case UNIFORM_RECT:
            parameterProxy.set(GEOMETRY, GeometryType.UNIFORM_RECT_GEOM);
            break;
        case RECTANGULAR:
            parameterProxy.set(GEOMETRY, GeometryType.RECTANGULAR_GEOM);
            break;
        case AFFINE:
            parameterProxy.set(GEOMETRY, GeometryType.AFFINE_GEOM);
            break;
        case CURVILINEAR:
            parameterProxy.set(GEOMETRY, GeometryType.CURVILINEAR_GEOM);
            break;
        case RADIAL:
            parameterProxy.set(GEOMETRY, GeometryType.RADIAL_GEOM);
            break;
        case SPHERICAL:
            parameterProxy.set(GEOMETRY, GeometryType.SPHERICAL_GEOM);
            break;
        }
        generateCoordsBox.setEnabled((selGeometry.equalsIgnoreCase(TRIVIAL) ||
                                      selGeometry.equalsIgnoreCase(UNIFORM_RECT) ||
                                      selGeometry.equalsIgnoreCase(RECTANGULAR) ||
                                      selGeometry.equalsIgnoreCase(AFFINE)) && 
                                     ((String) structTypeCombo.getSelectedItem()).equalsIgnoreCase(REGULAR));
    }//GEN-LAST:event_geometryTypeComboActionPerformed

    private void structTypeComboActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_structTypeComboActionPerformed
    {//GEN-HEADEREND:event_structTypeComboActionPerformed
        String selGeometry = (String) geometryTypeCombo.getSelectedItem(); 
        switch ((String) structTypeCombo.getSelectedItem()) {
        case REGULAR:
            parameterProxy.set(STRUCT_TYPE, StructureType.REGULAR);
            break;
        case IRREGULAR:
            parameterProxy.set(STRUCT_TYPE, StructureType.IRREGULAR);
            break;
        case TRIANGULATED:
            parameterProxy.set(STRUCT_TYPE, StructureType.TRIANGULATED);
            break;
        }
        generateCoordsBox.setEnabled((selGeometry.equalsIgnoreCase(TRIVIAL) ||
                                      selGeometry.equalsIgnoreCase(UNIFORM_RECT) ||
                                      selGeometry.equalsIgnoreCase(RECTANGULAR) ||
                                      selGeometry.equalsIgnoreCase(AFFINE)) && 
                                     ((String) structTypeCombo.getSelectedItem()).equalsIgnoreCase(REGULAR));
       
    }//GEN-LAST:event_structTypeComboActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JList componentList;
    private org.visnow.vn.gui.widgets.ExtendedSlider dimSlider;
    private javax.swing.JCheckBox generateCoordsBox;
    private javax.swing.JPanel geometryPanel;
    private javax.swing.JComboBox<String> geometryTypeCombo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private org.visnow.vn.gui.swingwrappers.RadioButton radioButton1;
    private org.visnow.vn.gui.swingwrappers.RadioButton radioButton2;
    private org.visnow.vn.gui.swingwrappers.RadioButton radioButton3;
    private javax.swing.JComboBox<String> structTypeCombo;
    // End of variables declaration//GEN-END:variables

    public static void main(String[] args)
    {
        VisNow.initLogging(true);
        LOGGER.debug("");
        UIStyle.initStyle();
        JFrame f = new JFrame();
        f.add(new GUI());
        f.pack();
        f.setLocationRelativeTo(null);
        f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        f.setVisible(true);
    }
}
